//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  摜ǂݍ񂾂猳̉摜t@Csvɂ@
//  I[sNZ̕`惂[hƃsNZ̃ItZbg[hݒ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0504 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, GDIPOBJ, GDIPAPI, GDIPUTIL, ExtDlgs,
  Spin;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    SpinEdit1: TSpinEdit;
    OpenPictureDialog1: TOpenPictureDialog;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private 錾 }
    FFileStream  : TMemoryStream;
    FGPBitmap    : TGPBitmap;
    FGPImageAttr : TGPImageAttributes;
    procedure GDIDrawImageToTImage;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  I[̕`惂[hƃItZbg[h';

  SpinEdit1.Value := Image1.Width;

  OpenPictureDialog1.InitialDir := ExtractFileDir(Application.ExeName);
  OpenPictureDialog1.FileName   := '503.bmp';
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FFileStream) then FreeAndNil(FFileStream);
  if Assigned(FGPBitmap) then FreeAndNil(FGPBitmap);
  if Assigned(FGPImageAttr) then FreeAndNil(FGPImageAttr);
end;

//=============================================================================
//  摜̓ǂݍ݃{^
//
//  摜\ɉ摜t@CȂĂ\Ȃ悤ɃXg[ɓǂݍ
//  ̃Xg[TGPBitmap𐶐
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LFileName : string;
begin
  if Assigned(FGPBitmap) then FreeAndNil(FGPBitmap);
  if Assigned(FFileStream) then FreeAndNil(FFileStream);

  if OpenPictureDialog1.Execute then begin
    LFileName := OpenPictureDialog1.FileName;
    OpenPictureDialog1.InitialDir := ExtractFileDir(LFileName);

    FFileStream := TMemoryStream.Create;
    FFileStream.LoadFromFile(LFileName);
    //Xg[ǂݏoTGPBitmap𐶐
    //TGPBitmapgp
    //TGPImageƐɓǂݍ߂Ȃ^t@C
    FGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FFileStream, soReference));

    //`TCYTSpinEdit̒lɏ]
    SpinEdit1Change(nil);
  end;
end;

//=============================================================================
//  ۑ{^
//  ۑ̂߂TBitmap𐶐ĕۑ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LSaveFileName : string;
  LBitmap       : TBitmap;
begin
  if not Assigned(FGPBitmap) then exit;

  LSaveFileName := ExpandFileName('Save.bmp');
  LBitmap := TBitmap.Create;
  try
    LBitmap.Assign(Image1.Picture.Bitmap);
    LBitmap.SaveToFile(LSaveFileName);
  finally
    FreeAndNil(LBitmap);
  end;
end;

//=============================================================================
//  SpinEdit1OnChangeCxg
//  TImage̕(摜̕\)ݒ
//  SpinEdit2(TImage̍)ReadOnlyɂĂ
//=============================================================================
procedure TForm1.SpinEdit1Change(Sender: TObject);
var
  LRatio : Double;
begin
  if not Assigned(FGPBitmap) then exit;
  if FGPBitmap.GetWidth <= 0 then exit;

  Image1.Picture.Assign(nil);

  //cvZ
  //cێĕ`悷
  LRatio := FGPBitmap.GetHeight / FGPBitmap.GetWidth;
  Image1.Width  := SpinEdit1.Value;
  Image1.Height := Trunc(LRatio * Image1.Width);

  GDIDrawImageToTImage;
end;

//=============================================================================
//  TCheckBoxOnClickCxg
//  摜`掞̏I[sNZ̕`惂[hƃsNZ̃ItZbg[hݒ
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if not Assigned(FGPBitmap) then exit;
  if FGPBitmap.GetWidth <= 0 then exit;

  Image1.Picture.Assign(nil);
  GDIDrawImageToTImage;
end;

//-----------------------------------------------------------------------------
//  ۂ̕`R[h
//-----------------------------------------------------------------------------
procedure TForm1.GDIDrawImageToTImage;
var
  LGPGraphic : TGPGraphics;
  LBackImage : string;
  LGPImage   : TGPImage;
  LGPTBrush  : TGPTextureBrush;
begin
  if not Assigned(FGPBitmap) then exit;

  //TGPGraphics̃IuWFNg𐶐
  //`͂TImageCanvas
  LGPGraphic := TGPGraphics.Create(Image1.Canvas.Handle);

  //wĩeNX`쐬ĕ`
  LBackImage := ExpandFileName('backTexture.gif');
  if FileExists(LBackImage) then begin
    LGPImage  := TGPImage.Create(LBackImage);
    LGPTBrush := TGPTextureBrush.Create(LGPImage);
    try
      LGPGraphic.FillRectangle(LGPTBrush,
                               MakeRect(0, 0, Image1.Width,Image1.Height));
    finally
      FreeAndNil(LGPImage);
      FreeAndNil(LGPTBrush);
    end;
  end;

  //I[sNZ̕`惂[hƃsNZ̃ItZbg[hݒ
  if CheckBox1.Checked then begin
    //TGPImageAttributesɂݒ肪ɂ邩mȂ
    //Lɂ͐ĂȂꍇɌĐǂ
    if not Assigned(FGPImageAttr) then begin
      FGPImageAttr := TGPImageAttributes.Create;
    end;
    FGPImageAttr.SetWrapMode(WrapModeTileFlipXY);
  end else begin
    if Assigned(FGPImageAttr) then FreeAndNil(FGPImageAttr);
  end;

  if CheckBox2.Checked then begin
    LGPGraphic.SetPixelOffsetMode(PixelOffsetModeHalf);
  end;

  //TGPBitmapTImageCanvasɕ`
  LGPGraphic.DrawImage(
              FGPBitmap,
              MakeRect(0, 0, Image1.Width, Image1.Height),
              0,
              0,
              FGPBitmap.GetWidth,
              FGPBitmap.GetHeight,
              UnitPixel,
              fGPImageAttr);

  //CreateIuWFNg͉
  if Assigned(LGPGraphic) then FreeAndNil(LGPGraphic);
end;

end.
