//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  Graphics32 gp TBitmap 摜̃TCYƕ ( Interpolation )
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2022N1028 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 10 rh 19043 Pro 64 bit + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Image2: TImage;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure ResizeBmpByGR32(SrcBmp: TBitmap; DstBmp: TBitmap;
      DstWidht, DstHeight: Integer; ResizeFlag: Boolean = True); overload;
    procedure ResizeBmpByGR32(SrcBmp: TBitmap; DstBmp: TBitmap; SrcX, SrcY, SrcCX,
      SrcCY: Integer; DstCX, DstCY: Integer; ResizeFlag: Boolean = True); overload;
    procedure DrawBackGroundImage(ACanvas: TCanvas; AFilePath: string);
  end;

var
  Form1: TForm1;

implementation

uses
  GR32,
  GR32_Resamplers;

{$R *.dfm}

//=============================================================================
//  TBitmap ̉摜TCY
//  TBitmap ȊỎ摜 TBitmap ɕϊΓlɂɃTCY\
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LSrcBmp : TBitmap;
  LDstBmp : TBitmap;
begin
  LSrcBmp := TBitmap.Create;
  LDstBmp := TBitmap.Create;
  try
    LSrcBmp.AlphaFormat := afDefined;
    LSrcBmp.LoadFromFile('virus detected.bmp');

    // TCYO TBitmap  TImage ɕ`
    DrawBackGroundImage(Image1.Canvas, 'backTexture_02.bmp');
    Image1.Canvas.Draw(0, 0, LSrcBmp);

    // 256 x 256 ɃTCY
    ResizeBmpByGR32(LSrcBmp, LDstBmp,256, 256);

    // TCY TBitmap  TImage ɕ`
    DrawBackGroundImage(Image2.Canvas, 'backTexture_02.bmp');
    Image2.Canvas.Draw(0, 0, LDstBmp);
  finally
    FreeAndNil(LSrcBmp);
    FreeAndNil(LDstBmp);
  end;
end;

//-----------------------------------------------------------------------------
//  Graphics32 gp TBitmap 摜̃TCY
//-----------------------------------------------------------------------------
procedure TForm1.ResizeBmpByGR32(SrcBmp, DstBmp: TBitmap; DstWidht,
  DstHeight: Integer; ResizeFlag: Boolean);
begin
  ResizeBmpByGR32(SrcBmp, DstBmp, 0, 0,
                  SrcBmp.Width, SrcBmp.Height, DstWidht, DstHeight, ResizeFlag);
end;

//-----------------------------------------------------------------------------
//  Graphics32 gp TBitmap 摜̃TCY
//   TBitmap ̕Iȋ`̈̊g / k\
//  ԃ[h TLinearResampler ( Coꎟ - oCjA ) ɌŒ
//
//  uses  GR32, GR32_Resamplers Kv
//-----------------------------------------------------------------------------
procedure TForm1.ResizeBmpByGR32(SrcBmp, DstBmp: TBitmap; SrcX, SrcY, SrcCX,
  SrcCY, DstCX, DstCY: Integer; ResizeFlag: Boolean);
var
  LSrcBmp32 : TBitmap32;
  LDstBmp32 : TBitmap32;
  LSrcRect  : TRect;
  LDstRect  : TRect;
begin
  // Ώۂ̉摜̋`̈
  LSrcRect := Rect(SrcX, SrcY, SrcCX, SrcCY);
  LDstRect := Rect(0,0, DstCX, DstCY);

  LSrcBmp32 := TBitmap32.Create;
  LDstBmp32 := TBitmap32.Create;
  try
    if ResizeFlag then begin
      LSrcBmp32.Resampler := TLinearResampler.Create;
    end;
    //  TBitmap  TBitmap32 ɕϊ
    SrcBmp.AlphaFormat := afDefined;
    LSrcBmp32.Assign(SrcBmp);

    // TBitmap32 ϊ̃TCYɂāC Canvas Ɍ̃rbg}bv`     L
    LDstBmp32.SetSize(LDstRect.Width, LDstRect.Height);
    LDstBmp32.Draw(LDstRect, LSrcRect, LSrcBmp32);

    // TCYɉ摜`悵 TBitmap32  TBitmap ɕϊ
    DstBmp.AlphaFormat := afDefined;
    DstBmp.Assign(LDstBmp32);
  finally
    FreeAndNil(LSrcBmp32);
    FreeAndNil(LDstBmp32);
  end;
end;
//----------------------------------------------------------------------------
//  TImage ̔wiƂĎs͗l̃uV`
//  TBitmap ̓ߏԂ̊mFp
//  ̖͗l镔͓܂͔̕ƂƂɂȂ
//----------------------------------------------------------------------------
procedure TForm1.DrawBackGroundImage(ACanvas: TCanvas; AFilePath: string);
var
  LBmpBack : TBitmap;
begin
  LBmpBack := TBitmap.Create;
  try
    LBmpBack.LoadFromFile(AFilePath);
    ACanvas.Brush.Style  := bsSolid;
    ACanvas.Brush.Bitmap := LBmpBack;
    ACanvas.FillRect(ACanvas.ClipRect);
  finally
    FreeAndNil(LBmpBack);
  end;
end;


end.
